//
//  AuthNContext.h
//  AuthN
//
//  Created by CA Technologies
//  Copyright (c) 2012 CA Technologies. All rights reserved.
//

#import <Foundation/Foundation.h>

#define AUTHN_HTTP_POST @"POST"
#define AUTHN_HTTP_GET @"GET"
#define AUTHN_HTTP_PUT @"PUT"
#define AUTHN_HTTP_DELETE @"DELETE"

#define AUTHN_AUTH_QUERY @"QueryAuth"
#define AUTHN_AUTH_BASIC @"BasicAuth"
#define AUTHN_AUTH_DIGEST @"DigestAuth"

typedef void ( ^ActionBlock)(void);
typedef id ( ^ActionBlockObj)(id obj);

@interface AuthNContext : NSObject

@property (nonatomic, strong) NSString *authType;
@property (nonatomic, strong) NSString *uid;
@property (nonatomic, strong) NSString *pw;
@property (nonatomic, strong) NSString *httpMethodOverride;
@property (nonatomic, strong) NSMutableDictionary *queryValues;
@property (nonatomic, strong) NSMutableDictionary *headers;
@property (nonatomic, strong) NSString *body;
@property (nonatomic, strong) NSString *urlStr;
@property (nonatomic) NSInteger statusCode;
@property (nonatomic) Boolean processCookies;
@property (nonatomic, copy) ActionBlock successBlock;
@property (nonatomic, copy) ActionBlock failureBlock;

- (void) addToQueryValuesTheKey:(id)key andValue:(id)value;
- (void) addToHeadersTheKey:(id)key andValue:(id)value;

- (void) reset;
- (NSString *) description;

@end
